%define py3_ver         %(echo `python3 -c "import sys; sys.stdout.write(sys.version[:3])"`)
%define py3_prefix      %(echo `python3 -c "import sys; sys.stdout.write(sys.prefix)"`)
%define py3_libdir      %{py3_prefix}/lib/python%{py3_ver}
%define py3_incdir      %{_includedir}/python%{py3_ver}
%define py3_sitedir     %{py3_libdir}/site-packages
%define py3_dyndir      %{py3_libdir}/lib-dynload

%define py2_ver         %(echo `python2 -c "import sys; sys.stdout.write(sys.version[:3])"`)
%define py2_prefix      %(echo `python2 -c "import sys; sys.stdout.write(sys.prefix)"`)
%define py2_libdir      %{py2_prefix}/lib/python%{py2_ver}
%define py2_incdir      %{_includedir}/python%{py2_ver}
%define py2_sitedir     %{py2_libdir}/site-packages
%define py2_dyndir      %{py2_libdir}/lib-dynload

Summary: The RPM package management system
Name: rpm
Version: 4.13.0.1
Release: 17
License: GPL-2.0-or-later

Source0: http://ftp.rpm.org/releases/rpm-4.13.x/rpm-%{version}.tar.bz2
Source2: ibmi-macros-ppc64
Source3: ibmi-macros-ppc
Source9: rpm-ibmi-macros

Source10: xcoff.attr
Source11: python.attr
Source12: pythoninterpreter.attr

Source20: xcoffdeps.pl
Source21: pythondeps.pl

Source22: check-files.pl

Patch0: rpm-pase.patch
Patch1: macros.in.patch
Patch2: rpmplugins.c.patch
Patch3: rpmfi.c.patch
Patch4: rpm-no-strip.patch
Patch6: rpm-disable-perl-requires.patch
Patch7: rpm-no-ima.patch
Patch8: rpm-mkdtemp.patch
Patch9: rpm-root-auth-check.patch
Patch10: rpm-allow-fat-subpackage.patch
Patch11: rpm-dev_t-64bit.patch
Patch13: rpm-python-xcoff-deps.patch
Patch14: rpm-python-linker-flags.patch

Patch99: rpm-config.rpath.patch

BuildRequires: autoconf
BuildRequires: automake
BuildRequires: libtool
BuildRequires: lua-devel
BuildRequires: nss-devel
BuildRequires: nspr-devel
BuildRequires: popt-devel
BuildRequires: bzip2-devel
BuildRequires: zlib-devel
BuildRequires: xz-devel
BuildRequires: db
BuildRequires: libiconv-devel
BuildRequires: file-devel
BuildRequires: pkg-config
BuildRequires: gettext-tools
BuildRequires: libutil-devel >= 0.6
BuildRequires: python2-devel
BuildRequires: python3-devel

Provides: rpm2cpio


%description
The RPM Package Manager (RPM) is a powerful command-line driven package
management system capable of installing, uninstalling, verifying, querying, and
updating software packages.  Each software package consists of an archive of
files along with information about the package like its version, a description,
etc.

%package devel
Summary: Development files for applications which will manipulate RPM packages.
Group: Development/Libraries
Requires: %{name} = %{version}

%description devel
This package contains the RPM C library and header files.  These development
files will simplify the process of writing programs which manipulate RPM
packages and databases. These files are intended to simplify the process of
creating graphical package managers or any other tools that need an intimate
knowledge of RPM packages in order to function.

This package should be installed if you want to develop programs that will
manipulate RPM packages and databases.

%package build
Summary: Development files for applications which will manipulate RPM packages.
Group: Development/Libraries
Requires: %{name} = %{version}

%description build
This package contains the RPM C library and header files.  These development
files will simplify the process of writing programs which manipulate RPM
packages and databases. These files are intended to simplify the process of
creating graphical package managers or any other tools that need an intimate
knowledge of RPM packages in order to function.

This package should be installed if you want to develop programs that will
manipulate RPM packages and databases.

%package -n python3-rpm
Summary: Python rpm package

%description -n python3-rpm
Python 3 rpm package

%package -n python2-rpm
Summary: Python rpm package

%description -n python2-rpm
Python rpm package


%prep
%setup -q 

%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch13 -p1
%patch14 -p1

autoreconf -fi

%patch99 -p1

# TODO: Add OS400 support to scripts/vpkg-provides.sh

perl -p -i -e 's|#!/bin/sh|#!/QOpenSys/usr/bin/sh|' scripts/gendiff

perl -p -i -e 's|#!/usr/bin/perl|#!'"%{_bindir}/perl|" scripts/perl.req scripts/perl.prov

# AIX GCC build will compile fine here, but will fail to link with error:
# collect2: fatal error: library libssp_nonshared not found
perl -p -i -e 's|-fstack-protector||g' configure

cp %{SOURCE10} %{SOURCE11} %{SOURCE12} fileattrs
cp %{SOURCE20} %{SOURCE21} scripts
cp %{SOURCE22} scripts/check-files
chmod +x scripts/*

%build

# The -L$PWD/build/.libs is a hack to get around the fact that libtool puts
# /opt/freeware/lib ahead of build/.libs and will find a (potentially older)
# installed librpmio by mistake

%configure \
    CFLAGS="$CFLAGS -Wno-attributes" \
    CPPFLAGS="-I%{_includedir}/nspr4 -I%{_includedir}/nss3" \
    LDFLAGS="-Wl,-blibpath:%{_libdir}:/QOpenSys/usr/lib -L$PWD/build/.libs" \
    LIBS='-lutil' \
    -C \
    --localstatedir=/QOpenSys/var \
    --with-aix-soname=svr4 \
    --enable-shared \
    --with-vendor=ibm \
    --with-external-db \
    --without-archive \
    --without-beecrypt \
    --without-selinux \
    --without-imaevm \
    --without-cap \
    --without-acl \
    --without-dmalloc \
    --without-hackingdocs \
    --disable-python \
    --disable-static \
    --disable-rpath \
    --disable-nls
    # --with-internal-beecrypt
    
cp -r python python3
cp -r python python2

%make_build

cd python3
python3 setup.py build
cd ..

cd python2
python2 setup.py build
cd ..

%install

# Fix /usr/lib paths
perl -p -i -e 's|/usr/lib/rpm|%{_libdir}/rpm|g' scripts/*

%make_install

cd python3
python3 setup.py install --no-compile --root %{buildroot}
rm %{buildroot}%{py3_sitedir}/*.egg-info
cd ..

cd python2
python2 setup.py install --no-compile --root %{buildroot}
rm %{buildroot}%{py2_sitedir}/*.egg-info
cd ..


find %{buildroot} -name \*.la | xargs rm

for lang in fr ja ko pl ru sk
do
rm -r %{buildroot}/%{_mandir}/$lang
done

# Add IBM i platform macro files
rm -r %{buildroot}/%{_libdir}/rpm/platform/*

mkdir -p %{buildroot}/%{_libdir}/rpm/platform/ppc64-ibmi
mkdir -p %{buildroot}/%{_libdir}/rpm/platform/ppc-ibmi

cp %{SOURCE2} %{buildroot}/%{_libdir}/rpm/platform/ppc64-ibmi/macros
cp %{SOURCE3} %{buildroot}/%{_libdir}/rpm/platform/ppc-ibmi/macros

for v in `seq 7 9`
do
  for r in `seq 1 9`
  do
    ln -s ppc64-ibmi %{buildroot}/%{_libdir}/rpm/platform/ppc64-ibmi${v}.${r}
    ln -s ppc-ibmi %{buildroot}/%{_libdir}/rpm/platform/ppc-ibmi${v}.${r}
  done
done

# Fix lib/rpm/macros paths
SEDCMD=

# We want these to use the PASE coreutils versions
# NOTE: most want a GNU install & GNU make, so we don't change those
for f in cat chgrp chmod chown cp file grep id mkdir mv rm sed
do
SEDCMD="${SEDCMD}s|%{_bindir}/$f|/QOpenSys/usr/bin/$f|; "
done

# These aren't supplied by PASE, use our prefix instead of /usr/bin
for f in curl gpg lrzip lzip pgp ssh git hg bzr quilt
do
SEDCMD="${SEDCMD}s|/usr/bin/$f|%{_bindir}/$f|; "
done

SEDCMD="${SEDCMD}s|/usr/bin/python|%{_bindir}/python3|; "

perl -p -i -e "$SEDCMD" %{buildroot}%{_libdir}/rpm/macros

# Fix Python macros
# use py_prefix/include instead of always /usr/include
perl -p -i -e 's|/usr/include|%{py_prefix}/include|' %{buildroot}/%{_libdir}/rpm/macros.python

# Make separate python 2 and python 3 macros scripts
cp -p %{buildroot}/%{_libdir}/rpm/macros.python %{buildroot}/%{_libdir}/rpm/macros.python2
mv %{buildroot}/%{_libdir}/rpm/macros.python %{buildroot}/%{_libdir}/rpm/macros.python3

# Use python2 or python3 instead of always "python"
perl -p -i -e 's|python |python2 |g' %{buildroot}/%{_libdir}/rpm/macros.python2
perl -p -i -e 's|python |python3 |g' %{buildroot}/%{_libdir}/rpm/macros.python3


# Fix up syslog.so plugin
# TODO: make rpm capable of loading .a-style plugins
ar -X64 x %{buildroot}%{_libdir}/rpm-plugins/syslog.so
mv shr_64.o %{buildroot}%{_libdir}/rpm-plugins/syslog.so
rm shr_64.imp

mkdir -p %{buildroot}%{_libdir}/rpm/macros.d
cp %{SOURCE9} %{buildroot}%{_libdir}/rpm/macros.d/macros.ibmi

%files
%defattr(-, qsys, *none)

%{_bindir}/gendiff
%{_bindir}/rpm
%{_bindir}/rpm2cpio
%{_bindir}/rpmdb
%{_bindir}/rpmgraph
%{_bindir}/rpmkeys
%{_bindir}/rpmquery
%{_bindir}/rpmsign
%{_bindir}/rpmspec
%{_bindir}/rpmverify

%{_libdir}/librpm.so.7*

%{_libdir}/librpmbuild.so.7*

%{_libdir}/librpmio.so.7*

%{_libdir}/librpmsign.so.7*

%{_libdir}/rpm-plugins/syslog.so

%{_libdir}/rpm/appdata.prov
%{_libdir}/rpm/brp-compress
%{_libdir}/rpm/brp-java-gcjcompile
%{_libdir}/rpm/brp-python-bytecompile
%{_libdir}/rpm/brp-python-hardlink
%{_libdir}/rpm/brp-strip
%{_libdir}/rpm/brp-strip-comment-note
%{_libdir}/rpm/brp-strip-shared
%{_libdir}/rpm/brp-strip-static-archive
%{_libdir}/rpm/check-buildroot
%{_libdir}/rpm/check-files
%{_libdir}/rpm/check-prereqs
%{_libdir}/rpm/check-rpaths
%{_libdir}/rpm/check-rpaths-worker
%{_libdir}/rpm/config.guess
%{_libdir}/rpm/config.sub
%{_libdir}/rpm/desktop-file.prov

%{_libdir}/rpm/fileattrs/appdata.attr
%{_libdir}/rpm/fileattrs/desktop.attr
%{_libdir}/rpm/fileattrs/elf.attr
%{_libdir}/rpm/fileattrs/font.attr
%{_libdir}/rpm/fileattrs/libtool.attr
%{_libdir}/rpm/fileattrs/mono.attr
%{_libdir}/rpm/fileattrs/ocaml.attr
%{_libdir}/rpm/fileattrs/perl.attr
%{_libdir}/rpm/fileattrs/perllib.attr
%{_libdir}/rpm/fileattrs/pkgconfig.attr
%{_libdir}/rpm/fileattrs/python.attr
%{_libdir}/rpm/fileattrs/pythoninterpreter.attr
%{_libdir}/rpm/fileattrs/script.attr
%{_libdir}/rpm/fileattrs/xcoff.attr
%{_libdir}/rpm/find-lang.sh
%{_libdir}/rpm/find-provides
%{_libdir}/rpm/find-requires
%{_libdir}/rpm/fontconfig.prov
%{_libdir}/rpm/libtooldeps.sh
%{_libdir}/rpm/macros
%{_libdir}/rpm/macros.perl
%{_libdir}/rpm/macros.php
%{_libdir}/rpm/macros.python2
%{_libdir}/rpm/macros.python3
%{_libdir}/rpm/macros.d
%{_libdir}/rpm/mkinstalldirs
%{_libdir}/rpm/mono-find-provides
%{_libdir}/rpm/mono-find-requires
%{_libdir}/rpm/ocaml-find-provides.sh
%{_libdir}/rpm/ocaml-find-requires.sh
%{_libdir}/rpm/perl.prov
%{_libdir}/rpm/perl.req
%{_libdir}/rpm/pkgconfigdeps.sh

%{_libdir}/rpm/platform/ppc64-ibmi*
%{_libdir}/rpm/platform/ppc-ibmi*

%{_libdir}/rpm/pythondeps.pl
%{_libdir}/rpm/rpm.daily
%{_libdir}/rpm/rpm.log
%{_libdir}/rpm/rpm.supp
%{_libdir}/rpm/rpm2cpio.sh
%{_libdir}/rpm/rpmdb_loadcvt
%{_libdir}/rpm/rpmdeps
%{_libdir}/rpm/rpmpopt-4.13.0.1
%{_libdir}/rpm/rpmrc
%{_libdir}/rpm/script.req
%{_libdir}/rpm/tgpg
%{_libdir}/rpm/xcoffdeps.pl

%{_mandir}/man1/gendiff.1
%{_mandir}/man8/rpm.8
%{_mandir}/man8/rpm2cpio.8
%{_mandir}/man8/rpmbuild.8
%{_mandir}/man8/rpmdb.8
%{_mandir}/man8/rpmdeps.8
%{_mandir}/man8/rpmgraph.8
%{_mandir}/man8/rpmkeys.8
%{_mandir}/man8/rpmsign.8
%{_mandir}/man8/rpmspec.8

%files build
%defattr(-, qsys, *none)

%{_bindir}/rpmbuild

%files devel
%defattr(-, qsys, *none)

%{_libdir}/librpm.so
%{_libdir}/librpmbuild.so
%{_libdir}/librpmsign.so
%{_libdir}/librpmio.so

%{_includedir}/rpm

%{_libdir}/pkgconfig/rpm.pc

%files -n python3-rpm
%defattr(-, qsys, *none)

%{py3_sitedir}/rpm

%files -n python2-rpm
%defattr(-, qsys, *none)

%{py2_sitedir}/rpm

%changelog
* Fri Mar 15 2019 - Kevin Adler <kadler@us.ibm.com>
- Require libutil 0.6 (libutil.so.2)

* Tue Jan 15 2019 - Kevin Adler <kadler@us.ibm.com>
- Fix bug in xcoff dependency generation

* Mon Jan 14 2019 - Kevin Adler <kadler@us.ibm.com>
- Speed up python and xcoff dependency generation
- Speed up unpackaged file checking
- Build python subpackages separately instead of building rpm twice
- Add platform macros up to IBM i 9.9
- Use SPDX license

* Tue Dec 11 2018 - Jesse R. Gorzinski <jgorzins@us.ibm.com>
- Add requirement on coreutils-gnu

* Tue Aug 07 2018 - Kevin Adler <kadler@us.ibm.com>
- Fix python dependency generation in rpm

* Wed Jul 18 2018 - Kevin Adler <kadler@us.ibm.com>
- Build rpm bindings for Python 3 too

* Sat Jul 14 2018 - Kevin Adler <kadler@us.ibm.com>
- Fix device handling in RPM

* Fri Jun 22 2018 - Kevin Adler <kadler@us.ibm.com>
- rpm should own the macros.d directory

* Mon Mar 12 2018 - Kevin Adler <kadler@us.ibm.com>
- Fix unshipped files

* Tue Mar 06 2018 - Kevin Adler <kadler@us.ibm.com>
- Need diffutils for diff -d to work in check-files

* Sun Mar 04 2018 - Kevin Adler <kadler@us.ibm.com>
- Allow fat sub-packages in addition to noarch ones
- Enable checking for unpackaged files
- Depend on python2-devel instead of python2 now
- Fix regex for XCOFF 32-bit binaries

* Sat Mar 03 2018 - Kevin Adler <kadler@us.ibm.com>
- Major spec cleanup
- Add build requirements

* Fri Feb 16 2018 - Kevin Adler <kadler@us.ibm.com>
- Ensure we use /QOpenSys/var
- Use PASE versions of core utilities to reduce dependencies
- Allow *ALLOBJ users to change ownership / permissions as well as uid 0

* Wed Dec 20 2017 - Kevin Adler <kadler@us.ibm.com>
- Add IBM i-specific macros and fix platform symlinks

* Wed Dec 20 2017 - Kevin Adler <kadler@us.ibm.com>
- Remove 64-bit GCC script workarounds

* Wed Nov 22 2017 - Kevin Adler <kadler@us.ibm.com>
- Fix shebang lines in rpm scripts

* Wed Nov 22 2017 - Kevin Adler <kadler@us.ibm.com>
- Clean up rpm spec file

* Wed Nov 22 2017 - Kevin Adler <kadler@us.ibm.com>
- Link with libutil for mkdtemp

* Wed Nov 22 2017 - Kevin Adler <kadler@us.ibm.com>
- Fix rpm build error

* Tue Nov 21 2017 - Kevin Adler <kadler@us.ibm.com>
- Add automatic dependency generation for XCOFF libraries and binaries
- Build libraries using svr4-style
- Build python2 bindings
- Fix python dependency generation
- Disable stripping binaries for now becuase it always fails

* Tue Nov 21 2017 - Kevin Adler <kadler@us.ibm.com>
- Remove manual Requires lines because we have automatic dependency generation

* Tue Nov 07 2017 - Kevin Adler <kadler@us.ibm.com>
- Fix licenses in spec files

* Thu Aug 24 2017 - Kevin Adler <kadler@us.ibm.com>
- Build rpm on IBM i
- Add IBM i version mapping to allow IBM i 7.1 rpms to be installed 7.2, etc
- Work around PASE bug returning incorrect symlink name lengths
- Work around PASE dlerror() not getting cleared or initialized
